#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include "libconfig.h"

/* read_vars -     
 *              .
 *
 * :
 * read_vars(config_t * foo, 	-   
 *             char * section,  -   . 
 *             
 *             char *var,       -   . 
 *             int  type,       -  : 
 *                                INT_T     - int
 *                                FLOAT_T   - double
 *                                CHARPTR_T - char *
 *             void **value,    -  ,  
 *                                   
 *
 *             .....            -   
 *                                var, type, value
 *
 *             NULL)            -    NULL
 * Return:            
 *   0 - OK
 *   1 -             
 *             
 */

int read_vars(config_t *foo, char *section, ...)
// char *var, int type, void **value, ...) 
{

  int t;
  char *vp;
  int vtype;
  char *svar;
  int i, count;
  int *ival;  
  double *fval;
  char **sval;
  va_list ap;

  va_start(ap, section);
    while ((vp = va_arg(ap, char *)) != NULL) {
     vtype = va_arg(ap, int);
     if ((i = config_get(*foo, section, vp, NULL,
	       &t,(void**) &svar, &count)) == 0) {
	 switch (vtype) {
	 
	 case INT_T:
                 ival = va_arg(ap, int*);
	 	 *ival = atoi(svar);
	 	 break;
	 case FLOAT_T:
  	 	 fval = va_arg(ap, double*);
	 	 *fval = atof(svar);
	 	 break;
	 default:
           sval = va_arg(ap, char**);
	   i = strlen(svar)+1;
	   if ((vp = malloc((size_t)i)) == NULL) return(1);
	   strcpy(vp, svar);
	   *sval = vp;
	   break;
	 }
     }
     else sval = va_arg(ap, char**);
    }
  va_end(ap);
  return(0);
}
