/* $Id: cas.c,v 1.1 1999/10/04 18:48:13 maxime Exp $ */
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <libconfig.h>
#include "libdev.h"
#include "local.h"

#define default_timeout 5.0
#define default_attempts 5
#define default_port_name "local"

read_int() {
  uchar buf[BUFSIZE];
  int i, l;

 l = read(fileno(stdin), buf, BUFSIZE-1);
// buf[0] = getch();

#ifdef DEBUG
  fprintf(stderr, "KEYBOARD INTERRUPT:(%d)\n", l);
  for (i=0; i<l; i++) if (buf[i] > '\040') fputc(buf[i], stderr);
                      else fprintf(stderr, " ^%c ", buf[i]+64);
  fputc('\n', stderr);
#endif
  if ((buf[0] == 'q') || (buf[0] == 'Q')) return(1);
  else return(0);
}

show_mass(double m) {
  printf(" = %f\n", m);
}

show_error(uchar *msg) {
  fprintf(stderr, "%s\n", msg);
  sleep(1);
}

main() {

  config_t foo;
  int i;
  int attempts;
  double m;
  double timeout;
  char *port_name;
  char buf[BUFSIZE];
  char *p;
  
  attempts = default_attempts;
  timeout = default_timeout;
  port_name = default_port_name;
  
  if (p=getenv("HOME")) strncpy(buf, p, BUFSIZE-30);
  else strcpy(buf, ".");
  strcat(buf, "/");
  strncat(buf, CONFIG_INI, 29);
  config_new(&foo);
  if(config_read(&foo, buf, CS_INI, NULL)) {
	perror(buf);
  } else {
    fprintf(stderr, "Reading config file ...\n");
    read_vars(&foo, "SCALES", 
  	     "device", CHARPTR_T, &port_name,
             "timeout", FLOAT_T, &timeout,
             "attempts", INT_T, &attempts,
             NULL);

    config_destroy(&foo);
  }

#ifdef DEBUG
  printf("Port: %s\n", port_name);
  printf("Timeout=%f\n", timeout);
  printf("Attempts=%d\n", attempts);
#endif    
  
//  initscr();
//  cbreak();
  m = 0.0;
  if ((i=ves(port_name, attempts, timeout, &m, &read_int)) == 1) {
     show_mass(m);
  }
  else {
    sprintf(buf, "   !(%d)", i);
    show_error(buf);
  }

//  endwin();
}

