/* $Id: era802.c,v 1.1 1999/10/04 18:48:13 maxime Exp $ 

era802.c -       
            -802
*/              
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <termios.h>
#include "libdev.h"
#include "local.h"

#define ZAP_PROG 1
#define ZAP_OTCH 2
#define ZAP_FISC 3
#define ZAP_END  9

#define attempts 3

uchar tab_alt2koi[] = {
/* 00 */ '\x00', '\x01', '\x02', '\x03', '\x04', '\x05', '\x06', '\x07', 
/* 0x8 */ '\x08', '\x09', '\x0a', '\x0b', '\x0c', '\x0d', '\x0e', '\x0f', 
/* 0x10 */ '\x10', '\x11', '\x12', '\x13', '\x14', '\x15', '\x16', '\x17', 
/* 0x18 */ '\x18', '\x19', '\x1a', '\x1b', '\x1c', '\x1d', '\x1e', '\x1f', 
/* 0x20 */ '\x20', '\x21', '\x22', '\x23', '\x24', '\x25', '\x26', '\x27', 
/* 0x28 */ '\x28', '\x29', '\x2a', '\x2b', '\x2c', '\x2d', '\x2e', '\x2f', 
/* 0x30 */ '\x30', '\x31', '\x32', '\x33', '\x34', '\x35', '\x36', '\x37', 
/* 0x38 */ '\x38', '\x39', '\x3a', '\x3b', '\x3c', '\x3d', '\x3e', '\x3f', 
/* 0x40 */ '\x40', '\x41', '\x42', '\x43', '\x44', '\x45', '\x46', '\x47', 
/* 0x48 */ '\x48', '\x49', '\x4a', '\x4b', '\x4c', '\x4d', '\x4e', '\x4f', 
/* 0x50 */ '\x50', '\x51', '\x52', '\x53', '\x54', '\x55', '\x56', '\x57', 
/* 0x58 */ '\x58', '\x59', '\x5a', '\x5b', '\x5c', '\x5d', '\x5e', '\x5f', 
/* 0x60 */ '\x60', '\x61', '\x62', '\x63', '\x64', '\x65', '\x66', '\x67', 
/* 0x68 */ '\x68', '\x69', '\x6a', '\x6b', '\x6c', '\x6d', '\x6e', '\x6f', 
/* 0x70 */ '\x70', '\x71', '\x72', '\x73', '\x74', '\x75', '\x76', '\x77', 
/* 0x78 */ '\x78', '\x79', '\x7a', '\x7b', '\x7c', '\x7d', '\x7e', '\x7f', 
/* 0x80 */ '\xe1', '\xe2', '\xf7', '\xe7', '\xe4', '\xe5', '\xf6', '\xfa', 
/* 0x88 */ '\xe9', '\xea', '\xeb', '\xec', '\xed', '\xee', '\xef', '\xf0', 
/* 0x90 */ '\xf2', '\xf3', '\xf4', '\xf5', '\xe6', '\xe8', '\xe3', '\xfe', 
/* 0x98 */ '\xfb', '\xfd', '\xff', '\xf9', '\xf8', '\xfc', '\xe0', '\xf1', 
/* 0xa0 */ '\xc1', '\xc2', '\xd7', '\xc7', '\xc4', '\xc5', '\xd6', '\xda', 
/* 0xa8 */ '\xc9', '\xca', '\xcb', '\xcc', '\xcd', '\xce', '\xcf', '\xd0', 
/* 0xb0 */ '\x90', '\x91', '\x92', '\x81', '\x87', '\xb2', '\xb5', '\xa8', 
/* 0xb8 */ '\xa8', '\xb5', '\xa1', '\xa8', '\xae', '\xae', '\xac', '\x83', 
/* 0xc0 */ '\x84', '\x89', '\x88', '\x86', '\x80', '\x8a', '\xaf', '\xb0', 
/* 0xc8 */ '\xab', '\xa5', '\xbb', '\xb8', '\xb1', '\xa0', '\xbe', '\xb9', 
/* 0xd0 */ '\xba', '\x88', '\x88', '\xaa', '\xa9', '\xa2', '\xa5', '\xbe', 
/* 0xd8 */ '\xbc', '\x85', '\x82', '\x8d', '\x8c', '\x8e', '\x8f', '\x8b', 
/* 0xe0 */ '\xd2', '\xd3', '\xd4', '\xd5', '\xc6', '\xc8', '\xc3', '\xde', 
/* 0xe8 */ '\xdb', '\xdd', '\xdf', '\xd9', '\xd8', '\xdc', '\xc0', '\xd1', 
/* 0xf0 */ '\xe5', '\xc5', '\x20', '\x20', '\xb4', '\xa4', '\xbd', '\xad', 
/* 0xf8 */ '\xb7', '\xa7', '\x9e', '\x96', '\xbf', '\x9d', '\x94', '\x9a'
};

uchar tab_koi2alt[] = {
/* 0x0 */ '\x00', '\x01', '\x02', '\x03', '\x04', '\x05', '\x06', '\x07', 
/* 0x8 */ '\x08', '\x09', '\x0a', '\x0b', '\x0c', '\x0d', '\x0e', '\x0f', 
/* 0x10 */ '\x10', '\x11', '\x12', '\x13', '\x14', '\x15', '\x16', '\x17', 
/* 0x18 */ '\x18', '\x19', '\x1a', '\x1b', '\x1c', '\x1d', '\x1e', '\x1f', 
/* 0x20 */ '\x20', '\x21', '\x22', '\x23', '\x24', '\x25', '\x26', '\x27', 
/* 0x28 */ '\x28', '\x29', '\x2a', '\x2b', '\x2c', '\x2d', '\x2e', '\x2f', 
/* 0x30 */ '\x30', '\x31', '\x32', '\x33', '\x34', '\x35', '\x36', '\x37', 
/* 0x38 */ '\x38', '\x39', '\x3a', '\x3b', '\x3c', '\x3d', '\x3e', '\x3f', 
/* 0x40 */ '\x40', '\x41', '\x42', '\x43', '\x44', '\x45', '\x46', '\x47', 
/* 0x48 */ '\x48', '\x49', '\x4a', '\x4b', '\x4c', '\x4d', '\x4e', '\x4f', 
/* 0x50 */ '\x50', '\x51', '\x52', '\x53', '\x54', '\x55', '\x56', '\x57', 
/* 0x58 */ '\x58', '\x59', '\x5a', '\x5b', '\x5c', '\x5d', '\x5e', '\x5f', 
/* 0x60 */ '\x60', '\x61', '\x62', '\x63', '\x64', '\x65', '\x66', '\x67', 
/* 0x68 */ '\x68', '\x69', '\x6a', '\x6b', '\x6c', '\x6d', '\x6e', '\x6f', 
/* 0x70 */ '\x70', '\x71', '\x72', '\x73', '\x74', '\x75', '\x76', '\x77', 
/* 0x78 */ '\x78', '\x79', '\x7a', '\x7b', '\x7c', '\x7d', '\x7e', '\x7f', 
/* 0x80 */ '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', 
/* 0x88 */ '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', 
/* 0x90 */ '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', 
/* 0x98 */ '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', '\x20', 
/* 0xa0 */ '\x20', '\x20', '\x20', '\x85', '\xf4', '\x20', '\x49', '\xf8', 
/* 0xa8 */ '\xcb', '\x20', '\x20', '\x20', '\x20', '\xf6', '\x20', '\x20', 
/* 0xb0 */ '\x20', '\x20', '\x20', '\x85', '\xf4', '\x20', '\x49', '\xf8', 
/* 0xb8 */ '\xcb', '\x20', '\x20', '\x20', '\x20', '\xf6', '\x20', '\x20', 
/* 0xc0 */ '\x9e', '\x80', '\x81', '\x96', '\x84', '\x85', '\x94', '\x83', 
/* 0xc8 */ '\x95', '\x88', '\x89', '\x8a', '\x8b', '\x8c', '\x8d', '\x8e', 
/* 0xd0 */ '\x8f', '\x9f', '\x90', '\x91', '\x92', '\x93', '\x86', '\x82', 
/* 0xd8 */ '\x9c', '\x9b', '\x87', '\x98', '\x9d', '\x99', '\x97', '\x9a', 
/* 0xe0 */ '\x9e', '\x80', '\x81', '\x96', '\x84', '\x85', '\x94', '\x83', 
/* 0xe8 */ '\x95', '\x88', '\x89', '\x8a', '\x8b', '\x8c', '\x8d', '\x8e', 
/* 0xf0 */ '\x8f', '\x9f', '\x90', '\x91', '\x92', '\x93', '\x86', '\x82', 
/* 0xf8 */ '\x9c', '\x9b', '\x87', '\x98', '\x9d', '\x99', '\x97', '\x9a' 
};


alt2koi(uchar *str, int len) {
register int i;

for (i=0; i<len; i++) str[i] = tab_alt2koi[str[i]];
}

koi2alt(uchar *str, int len) {
register int i;

for (i=0; i<len; i++) str[i] = tab_koi2alt[str[i]];
}


int era_open(char *port_name) {
 static struct termios stty;
 static char *pn;
 static int fp = -1;
 int i;

 if (port_name) {
    
    if (fp != -1) return(-1);
    
    while (mdm_lock(port_name) != 0) {
      sleep(1);
      if (i++ > 3) return(-1);
    }

//timeout=30.0;
    fp=open_port (port_name, B9600, 8, 'N', 1, 0, &stty);
    if (fp != -1) {
       i = strlen(port_name) + 1;
       pn = malloc(i);
       strcpy(pn, port_name);
    }
    return(fp);

 }
 else {
    mdm_unlock(pn);
    close_port(fp, &stty);
    fp = -1;
    return(0);
 }
    
}

/*
 *      
 */
era_chsum(str, len)
uchar *str;	/*   */
int len;	/*     */
{
  short unsigned int s, i;
  
  for (i=0, s=0; i<len; i++) {
      s += (int) str[i];
      if (s & 0xFF00) s = (s & 0xFF) + 1;
  }
  return(s);
}

/* era_putget() -       .
 * :
 *  fp  - file descriptor
 *  buf -      
 *  len -   
 *
 * :
 *  buf -  ( )
 *
 * Return:
 *  >1 - OK,  buf  , returned -  
 *   1 - OK,      
 *   0 - timeout
 *  -1 -   
 *  -2 -  /
 *  -3 -    
 */
era_putget(int fp, char *buf, uint len, double tim) {
  char inbuf[BUFSIZE];
  char *cp;
  int i, s;
  int att;

  buf[len] = era_chsum(buf, len);
  att = attempts;
  while (att--) {
     write(fp, buf, len+1);
     i=read_box(fp, inbuf, tim, NULL);
     if (i<=0) return(i);
     switch (inbuf[0]) {
     case ACK:	/* OK */
          if (i>1) {
             i--;
             cp = &inbuf[1];
             while ((cp[0] != STX) || ((cp[1] & 0xFF) != i) 
                  || ((cp[i-1] & 0xFF) != era_chsum(cp, i-1))) {
                inbuf[0] = NAK;
                write(fp, inbuf, 1);
                if ((i=read_box(fp, cp, tim, NULL)) <= 0) break;
             }
             if (i>0) {
               memcpy(buf, cp, --i);
               inbuf[0] = ACK;
               write(fp, inbuf, 1);
             }
          }
          else buf[0] = inbuf[0];
          return(i);
          break;
     case NAK:	/*     .  */
          continue;
          break;
     case NAK1:	/* .  .  ENQ */
          goto err;
          break;
     case NAK2:	/*    . . .  ENQ */
          goto err;
          break;
     default:	/*    */
          goto err;
          break;
     }
  } 
err:
  return(-3);
}

/* era_get() -      .
 *               buf.
 * Return:
 *  >=1 - OK,  
 *  0 - 
 * -1 -   
 * -2 -  /
 */
era_get(int fp, char *buf, double tim) {
  int i, c, att;
  char inbuf[BUFSIZE];
  
  att = attempts;
  while (att--) {
    i=read_box(fp, inbuf, tim, NULL);
    if (i<=0) return(i);
    if ((inbuf[0] != STX) || ((inbuf[1] & 0xFF) != i) 
         || ((inbuf[i-1] & 0xFF) != era_chsum(inbuf, i-1))) {
       inbuf[0] = NAK;
       write(fp, inbuf, 1);
       continue;
    }
    else {
       i--;
       memcpy(buf, inbuf, i);
       inbuf[0] = ACK;
       write(fp, inbuf, 1);
       break;
    }
  }
  return(i);
}  

send_enq(fp) {
  char buf[64];
  int j;
#ifdef DEBUG
  int i;
    
  fprintf(stderr, "Send ENQ\n");
#endif  
  buf[0] = ENQ;
  write(fp, buf, 1);
  j=read_box(fp, buf, 1.0, NULL);

#ifdef DEBUG
    fprintf(stderr, "REPLY on ENQ: %d chars:", j);
    for (i=0; i<j; i++)
       if (buf[i] > '\040') fputc(buf[i], stderr);
         else fprintf(stderr, " ^%c ", buf[i]+64);
    fputc('\n', stderr);
#endif  
  return(j);
}

zapros_1(fp, tip, passwd)
int fp;
int tip;
char *passwd;
{
  uchar buf[BUFSIZE];
  int i;
#ifdef DEBUG
  int j;
#endif  
  
  
  buf[0] = STX;
  buf[1] = 8;
  buf[2] = tip;
  i = atoi(passwd);
  buf[6] = (char) (i & 0xf);
  i >>= 8;
  buf[5] = (char) (i & 0xf);
  i >>= 8;
  buf[4] = (char) (i & 0xf);
  i >>= 8;
  buf[3] = (char) (i & 0xf);
#ifdef DEBUG
  fprintf(stderr, "Send zapros %d\n", tip);
#endif 
  i=era_putget(fp, buf, 7, 1.0);
#ifdef DEBUG
  fprintf(stderr, "REPLY on zapros: %d chars:", i);
  for (j=0; j<i; j++)
     if (buf[j] > '\040') fputc(buf[j], stderr);
       else fprintf(stderr, " ^%c ", buf[j]+64);
  fputc('\n', stderr);
#endif  
  return(i);
}  

zapros_info(fp, password)
int fp;
char *password;
{
  uchar buf[BUFSIZE];
  int i;
#ifdef DEBUG
  int j;
#endif  
  
  if ((send_enq(fp) > 0) && (zapros_1(fp, ZAP_OTCH, password) > 0)) {

     buf[0] = STX;
     buf[1] = 4; 		/*  */
     buf[2] = 52;		/*   */
#ifdef DEBUG
     fprintf(stderr, "Send info-zapros\n");
#endif 

     i=era_putget(fp, buf, 3, 1.0);
     alt2koi(buf, i-1);

#ifdef DEBUG
     fprintf(stderr, "REPLY on zapros: %d chars:", i);
     for (j=0; j<i; j++)
        if (buf[j] > '\040') fputc(buf[j], stderr);
          else fprintf(stderr, " ^%c ", buf[j]+64);
     fputc('\n', stderr);
#endif
 
    while ((i=era_get(fp, buf, 1.0)) > 0) {
       alt2koi(buf, i-1);
#ifdef DEBUG
       fprintf(stderr, "REPLY on zapros: %d chars:", i);
       for (j=0; j<i; j++)
        if (buf[j] > '\040') fputc(buf[j], stderr);
          else fprintf(stderr, " ^%c ", buf[j]+64);
       fputc('\n', stderr);
#endif
     }
  }
#ifdef DEBUG
  fprintf(stderr, "Done: %d\n", i);  
#endif
  return(i);
}  

era_prog_tovar(fp, password, cod, name, gr_NDS, gr_TOV, barcode, 
		depart, drob, test_ost, cena, ost)
int	fp;		/* file descriptor		*/	       
char	*password;	/* 			*/
uint 	cod;		/*   1-2500 		*/
uchar 	*name;		/*  12  	*/
uint 	gr_NDS;		/*   0-4 		*/
uint 	gr_TOV; 	/*   1-32 	*/
char 	*barcode;	/* -, 13  	*/
uint 	depart;		/*  0-31 			*/
uint 	drob;	 	/* 0 -  -  , 
				 ..  	*/
uint 	test_ost;/* 0 -     , 
				 -  	*/
double 	cena;		/*   		*/
double 	ost;		/*   () 	*/
{
 char buf[BUFSIZE], buf1[64];
 int i, j;
 
 /*    */
 if ((cod > 2500) || (gr_NDS > 4) || (gr_TOV > 32) || (depart > 31) ||
     (cena < 0.0) || (cena > 2E9) || (ost < 0.0) || (ost >= 2E9))
     return(-4);

 if ((send_enq(fp) > 0) && (zapros_1(fp, ZAP_PROG, password) > 0)) {

          /*   */
          buf[0] = STX;
          buf[1] = 10;
          buf[2] = 20;
          buf[4]=cod & 0xFF;
          buf[3]=(cod >> 8) & 0xFF;
          buf[8] = buf[7] = buf[6] = buf[5] = '\0';
#ifdef DEBUG
       fprintf(stderr, "Rests clear\n");
#endif
       
       i=era_putget(fp, buf, 9, 1.0);

#ifdef DEBUG
       fprintf(stderr, "Result: %d\n", i);
#endif

    /*     */
    buf[0]=STX;
    buf[1]=30;
    buf[2]=24;
    buf[4]=cod & 0xFF;
    buf[3]=(cod >> 8) & 0xFF;
    for (i=0,j=strlen(name); i<12; i++) 
      if (i<j) buf[i+5] = tab_koi2alt[name[i]];
      else buf[i+5] = '\040';
    buf[17] = (char) gr_NDS;
    buf[18] = (char) gr_TOV;
    
    if ((i=strlen(barcode)) > 13) i=13;
    buf1[0] = '0';
    for (j=0; j<(13-i); j++) buf1[j+1] = '0';
    for (i=0; j<13; j++,i++) buf1[j+1] = barcode[i];
    buf1[14]='\0';
    for (i=0; i<7; i++) {
      j = buf1[i*2];
      j <<= 4;
      j &= 0xF0;
      buf[19+i] = (buf1[i*2+1] & 0x0F) | j;
    }
    
    buf[26] = (char) depart;
    buf[27] = drob ? '\001' : '\0';
    buf[28] = test_ost ? '\001' : '\0';
#ifdef DEBUG
    fprintf(stderr, "Programming of good %d\n", cod);
#endif
    i=era_putget(fp, buf, 29, 1.0);
#ifdef DEBUG
    fprintf(stderr, "Result: %d\n", i);
#endif

    if (i>=1) {
       /*    */
       buf[0] = STX;
       buf[1] = 11;
       buf[2] = 13;
       
       buf[4]=cod & 0xFF;
       buf[3]=(cod >> 8) & 0xFF;
       j=kop(cena);
       buf[8] = j & 0xFF;
       j >>= 8;
       buf[7] = j & 0xFF;
       j >>= 8;
       buf[6] = j & 0xFF;
       j >>= 8;
       buf[5] = j & 0xFF;
       
       buf[9] = '\001';	/*   */

#ifdef DEBUG
       fprintf(stderr, "Programming of price\n");
#endif
       
       i=era_putget(fp, buf, 10, 1.0);

#ifdef DEBUG
       fprintf(stderr, "Result: %d\n", i);
#endif
       
       if ((i>0) && test_ost) {
          /*   */
          buf[0] = STX;
          buf[1] = 10;
          buf[2] = 20;
          buf[4]=cod & 0xFF;
          buf[3]=(cod >> 8) & 0xFF;
          j = rint(ost);
          buf[8] = j & 0xFF;
          j >>= 8;
          buf[7] = j & 0xFF;
          j >>= 8;
          buf[6] = j & 0xFF;
          j >>= 8;
          buf[5] = j & 0xFF;
#ifdef DEBUG
       fprintf(stderr, "Programming of rests\n");
#endif
       
       i=era_putget(fp, buf, 9, 1.0);

#ifdef DEBUG
       fprintf(stderr, "Result: %d\n", i);
#endif
       }
    }
 }
 zapros_1(fp, ZAP_END, password);
 return(i);
}   


       
otch_tovar(fp, password, first, last)
int fp;
char *password;
uint first;
uint last;
{
  uchar buf[BUFSIZE];
  int i;
  uint l;
#ifdef DEBUG
  int j, k;
     uint nt, ngr, cena;
#endif  

  if ((first > last) || (last > 2500)) return(-4);
  
  if ((send_enq(fp) > 0) && (zapros_1(fp, ZAP_OTCH, password)) > 0) {

     buf[0] = STX;
     buf[1] = 8; 		/*  */
     buf[2] = 50;		/*   */
#ifdef DEBUG
     fprintf(stderr, "Send zapros on tovar\n");
#endif 
     int2str(first, &buf[3], 2);
     int2str(last, &buf[5], 2);
     first = l + 1;

     i=era_putget(fp, buf, 7, 1.0);
     alt2koi(&buf[6], 12);

#ifdef DEBUG
     nt=buf[4]; nt <<= 8; nt |= buf[5];
     ngr = buf[18]; ngr >>= 5; ngr &= 0x7;
     cena = buf[20]; cena <<= 8; 
     cena |= buf[21]; cena <<= 8;
     cena |= buf[22]; cena <<= 8;
     cena |= buf[23]; 
     
     fprintf(stderr, "tovar REPLY: NS=%d; NT=%d; Name=%12s; TGR=%d;\
NGR=%d; OTD=%d; DROB=%d; KZ=%d; FICS=%d; CENA=%d; \
BAR=%o-%o-%o-%o-%o-%o-%o\n", 
buf[3], nt, &buf[6], buf[18] & 0x1F, ngr, buf[19] & 0x1F, 
(buf[19] & 0x20) ? 1 : 0, (buf[19] & 0x40) ? 1 : 0, 
(buf[19] & 0x80) ? 1 : 0, cena, buf[24], buf[25], buf[26], buf[27], buf[28], buf[29], buf[30]);
#endif
 
    while ((i=era_get(fp, buf, 1.0)) > 0) {
       alt2koi(&buf[6], 12);
#ifdef DEBUG
     nt=buf[4]; nt <<= 8; nt |= buf[5];
     ngr = buf[18]; ngr >>= 5; ngr &= 0x7;
     cena = buf[20]; cena <<= 8; 
     cena |= buf[21]; cena <<= 8;
     cena |= buf[22]; cena <<= 8;
     cena |= buf[23]; 
     fprintf(stderr, "tovar REPLY: NS=%d; NT=%d; Name=%12s; TGR=%d;\
NGR=%d; OTD=%d; DROB=%d; KZ=%d; FICS=%d; CENA=%d; \
BAR=%o-%o-%o-%o-%o-%o-%o\n", 
buf[3], nt, &buf[6], buf[18] & 0x1F, ngr, buf[19] & 0x1F, 
(buf[19] & 0x20) ? 1 : 0, (buf[19] & 0x40) ? 1 : 0, 
(buf[19] & 0x80) ? 1 : 0, cena, buf[24], buf[25], buf[26], buf[27], buf[28], buf[29], buf[30]);
#endif
     }
  }
  zapros_1(fp, ZAP_END, password);
#ifdef DEBUG
  fprintf(stderr, "Done: %d\n", i);  
#endif
  return(i);
}  

otch_ost(fp, password, first, last)
int fp;
char *password;
uint first;
uint last;
{
  uchar buf[BUFSIZE];
  int i;
#ifdef DEBUG
  int j, k;
     uint nt, rest;
#endif  

  if ((first > last) || (last > 2500)) return(-4);
  
  if ((send_enq(fp) > 0) && (zapros_1(fp, ZAP_OTCH, password)) > 0) {

     buf[0] = STX;
     buf[1] = 8; 		/*  */
     buf[2] = 42;		/*   */
#ifdef DEBUG
     fprintf(stderr, "Send zapros on rests\n");
#endif 
     buf[3] = (first >> 8) & 0xFF;
     buf[4] = first & 0xFF;
     buf[5] = (last >> 8) & 0xFF;
     buf[6] = last & 0xFF;

     i=era_putget(fp, buf, 7, 1.0);
     alt2koi(&buf[6], 12);

#ifdef DEBUG
     nt=buf[4]; nt <<= 8; nt |= buf[5];
     rest = buf[18]; rest <<= 8; 
     rest |= buf[19]; rest <<= 8;
     rest |= buf[20]; rest <<= 8;
     rest |= buf[21]; 
     
     fprintf(stderr, "rests REPLY: NS=%d; NT=%d; Name=%12s; Rests=%d\n",
      buf[3], nt, &buf[6], rest);
#endif
 
    while ((i=era_get(fp, buf, 1.0)) > 0) {
       alt2koi(&buf[6], 12);
#ifdef DEBUG
     nt=buf[4]; nt <<= 8; nt |= buf[5];
     rest = buf[18]; rest <<= 8; 
     rest |= buf[19]; rest <<= 8;
     rest |= buf[20]; rest <<= 8;
     rest |= buf[21]; 
     
     fprintf(stderr, "rests REPLY: NS=%d; NT=%d; Name=%12s; Rests=%d\n",
      buf[3], nt, &buf[6], rest);
#endif
     }
  }
  zapros_1(fp, ZAP_END, password);
#ifdef DEBUG
  fprintf(stderr, "Done: %d\n", i);  
#endif
  return(i);
}  


int str2int(uchar *str, uint l) {
  int i;
  int res;
  
  for (i=0, res=0; i<l; i++) {
    res <<= 8;
    res |= str[i];
  }
  return(res);
}

int2str(uint i, uchar *str, uint l) {
  register int j;
    
  for (j=l-1; j>=0; j--) {
    str[j] = 0xFF & i;
    i >>= 8;
  }
}

/* free_tovar_list() -  ,  
 *                     
 */
free_tovar_list(pt)
tovar_info **pt;
{
  if (*pt) {
     while ((*pt)->next != NULL) *pt = (*pt)->next;
     while ((*pt)->pred != NULL) {
        *pt = (*pt)->pred;
        free((*pt)->next);
     }
     free(*pt);
  }
}

/* era_otch_tovar() -     
 *
 * Return:
 *   NULL -         Z-
 *    -     
 */
int era_otch_tovar(fp, password, first, last, chain)
int fp;
char *password;
uint first;
uint last;
tovar_info **chain;
{
  uchar buf[BUFSIZE];
  int i, j, n;
  tovar_info *p, *pp, *p0;
  long long ll;
#ifdef DEBUG
  int k;
#endif  
  uint nt, ngr, cena;
  double timeout;

  if ((first > last) || (last > 2500)) return(-4);
  n = 0;
  
  p = p0 = pp = NULL;
  timeout = (last + 1 - first) * 0.03;
  if (timeout < 1.0) timeout = 1.0; 
  if ((send_enq(fp) > 0) && (zapros_1(fp, ZAP_OTCH, password)) > 0) {

     /*      */
     buf[0] = STX;
     buf[1] = 8; 		/*  */
     buf[2] = 43;		/*   */
#ifdef DEBUG
     fprintf(stderr, "Send zapros on tovar\n");
#endif 
     int2str(first, &buf[3], 2);
     int2str(last, &buf[5], 2);

     buf[6] = last & 0xFF;
     i=era_putget(fp, buf, 7, timeout);
     while (i > 0) {
       if ((i>1) && (strncmp(&buf[4], "\231\231", 2)!=0)) {
         if (strncmp(&buf[4], "\xFF\xFF\xFF\xFF", 4)==0) 
           break;
         nt=str2int(&buf[4], 2);
         pp = p;
       
         if ((p = malloc(sizeof(tovar_info))) == NULL) {
            perror("era_otch_tovar");
            return(-2);
         }
         else n++;
         
         p->pred = pp;
         p->next = NULL;
         if (pp) pp->next = p;
         else p0 = p;

         p->cod = nt;
       
         for (j=0; j<12; j++) p->name[j] = tab_alt2koi[buf[j+6]];
         p->name[j] = '\0';
       
         p->num = str2int(&buf[18], 4);

         ll = buf[22]; ll <<= 8;
         ll |= buf[23]; ll <<= 8;
         ll |= buf[24]; ll <<= 8;
         ll |= buf[25]; ll <<= 8;
         ll |= buf[26]; 
         p->sum = ll/100.0;
         
         p->cena = 0.0;
         p->depart = 0;
         p->barcode[0] = '\0';
       }
       i=era_get(fp, buf, timeout);
     }  
     
     i=zapros_1(fp, ZAP_END, password);
#ifdef DEBUG
     fprintf(stderr, "Done: %d\n", i);  
#endif

#ifdef FULL_INFO
     /*        */
     if (i>0) 
        if ((i=send_enq(fp)) > 0)  i=zapros_1(fp, ZAP_OTCH, password);
#ifdef DEBUG
       fprintf(stderr, "Full info on tovar\n");
#endif 
     p = p0;
     while ((i>0) && p) {
        buf[0] = STX;
        buf[1] = 8; 		/*  */
        buf[2] = 50;		/*   */
        int2str(p->cod, &buf[3], 2);
        int2str(p->cod, &buf[5], 2);

        if ((i=era_putget(fp, buf, 7, 1.0)) == 1) i=era_get(fp, buf, 1.0);
        if (i>0) {
        
          nt=str2int(&buf[4], 2);
          if (p->cod == nt) {
             p->barcode[0] = '\0';
             p->cena = str2int(&buf[20], 4);
             p->cena = p->cena / 100.0;
             p->depart = buf[19] & 0x1F;
             for (j=0; j<7; j++) {
               p->barcode[j*2] = ((buf[24+j] >> 4) & 0xF) + '0';
               p->barcode[j*2+1] = (buf[24+j] & 0xF) + '0';
             }
             p->barcode[13] = '\0';
             p = p->next;
          }
          else i = 0;
          while ((j = era_get(fp, buf, 1.0))>0) {
                j=strncmp(&buf[4], "\xFF\xFF\xFF\xFF", 4);
                if (j == 0) break;
          }
//          i = (i>0) && (j>0) ? 1 : 0;
        }  
     }
     i=zapros_1(fp, ZAP_END, password);
#endif
  }
#ifdef DEBUG
        fprintf(stderr, "Result:%d\n", i);
#endif 

  p = p0;
  if (i<=0) {
    free_tovar_list(&p);
    n = -1;
  }
  *chain = p;
  return(n);
}             
