/* $Id: fiscal.c,v 1.1 1999/10/04 18:48:13 maxime Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/wait.h>
#include <signal.h>
#include "libdev.h"
#include "local.h"

#define COD_READY 100
#define COD_DONE COD_READY+1
#define COD_COMP COD_DONE+2

#define maria_BEG 253
#define maria_END 254

#define COD_INFO 10
#define COD_WARN 20
#define COD_ERROR 40

#define MARIA_DISCONNECT_TIMEOUT 6

#define kop(grn) ((int) rint(grn * 100))

static double printer_delay = 0.5;
pid_t maria_SON = 0;

unsigned char cod_table [] = {
/*0x00*/ '\x0', '\x1', '\x2', '\x3', '\x4', '\x5', '\x6', '\x7',
/*0x08*/ '\x8', '\x9', '\xa', '\xb', '\xc', '\xd', '\xe', '\xf',
/*0x10*/ '\x10', '\x11', '\x12', '\x13', '\x14', '\x15', '\x16', '\x17',
/*0x18*/ '\x18', '\x19', '\x1a', '\x1b', '\x1c', '\x1d', '\x1e', '\x1f',
/*0x20*/ '\x20', '\x21', '\x22', '\x23', '\x24', '\x25', '\x26', '\x27',
/*0x28*/ '\x28', '\x29', '\x2a', '\x2b', '\x2c', '\x2d', '\x2e', '\x2f',
/*0x30*/ '\x30', '\x31', '\x32', '\x33', '\x34', '\x35', '\x36', '\x37',
/*0x38*/ '\x38', '\x39', '\x3a', '\x3b', '\x3c', '\x3d', '\x3e', '\x3f',
/*0x40*/ '\x40', '\x41', '\x42', '\x43', '\x44', '\x45', '\x46', '\x47',
/*0x48*/ '\x48', '\x49', '\x4a', '\x4b', '\x4c', '\x4d', '\x4e', '\x4f',
/*0x50*/ '\x50', '\x51', '\x52', '\x53', '\x54', '\x55', '\x56', '\x57',
/*0x58*/ '\x58', '\x59', '\x5a', '\x5b', '\x5c', '\x5d', '\x5e', '\x5f',
/*0x60*/ '\x60', '\x61', '\x62', '\x63', '\x64', '\x65', '\x66', '\x67',
/*0x68*/ '\x68', '\x69', '\x6a', '\x6b', '\x6c', '\x6d', '\x6e', '\x6f',
/*0x70*/ '\x70', '\x71', '\x72', '\x73', '\x74', '\x75', '\x76', '\x77',
/*0x78*/ '\x78', '\x79', '\x7a', '\x7b', '\x7c', '\x7d', '\x7e', '\x7f',
/*0x80*/ '\xc4', '\xb3', '\xda', '\xbf', '\xc0', '\xd9', '\xc3', '\xb4',
/*0x88*/ '\xc2', '\xc1', '\xc5', '\xdf', '\xdc', '\xdb', '\xdd', '\xde',
/*0x90*/ '\xb0', '\xb1', '\xb2', '\xda', '\xfe', '\xfa', '\xfb', '\x3d',
/*0x98*/ '\x3c', '\x3e', '\xff', '\xd9', '\xfa', '\xfd', '\xfa', '\x25',
/*0xA0*/ '\xcd', '\xba', '\xd5', '\xf1', '\xf3', '\xc9', '\x69', '\xf5',
/*0xA8*/ '\xbb', '\xd4', '\xd3', '\xc8', '\xbe', '\xa3', '\xbc', '\xc6',
/*0xB0*/ '\xc7', '\xcc', '\xb5', '\xf0', '\xf2', '\xb9', '\x49', '\xf4',
/*0xB8*/ '\xcb', '\xcf', '\xd0', '\xca', '\xd8', '\x83', '\xce', '\xfc',
/*0xC0*/ '\xee', '\xa0', '\xa1', '\xe6', '\xa4', '\xa5', '\xe4', '\xa3',
/*0xC8*/ '\xe5', '\xa8', '\xa9', '\xaa', '\xab', '\xac', '\xad', '\xae',
/*0xD0*/ '\xaf', '\xef', '\xe0', '\xe1', '\xe2', '\xe3', '\xa6', '\xa2',
/*0xD8*/ '\xec', '\xeb', '\xa7', '\xe8', '\xed', '\xe9', '\xe7', '\xea',
/*0xE0*/ '\x9e', '\x80', '\x81', '\x96', '\x84', '\x85', '\x94', '\x83',
/*0xE8*/ '\x95', '\x88', '\x89', '\x8a', '\x8b', '\x8c', '\x8d', '\x8e',
/*0xF0*/ '\x8f', '\x9f', '\x90', '\x91', '\x92', '\x93', '\x86', '\x82',
/*0xF8*/ '\x9c', '\x9b', '\x87', '\x98', '\x9d', '\x99', '\x97', '\x9a' } ;

uchar * maria_error(int errcod) {
char buf[20];
char *p;
static char *errmsg[]={ "˦    Ҧ",	/* 41 */
	   "   ϧ   ",/* 42 */
	   "æ ϧ   ",		/* 43 */
	   " ̦Φ '",				/* 44 */
	   "  ",				/* 45 */
	   "   Ʀϧ 'Ԧ",		/* 46 */
	   " ",				/* 47 */
	   "   Φ ",             	/* 48 */
	   "  ",				/* 49 */
	   "Ȧ  Z-צ",				/* 50 */
	   "   \"\"",	/* 51 */
	   "צ ",					/* 52 */
	   "  צצ ",			/* 53 */
	   "Z-צ    Ҧ",		/* 54 */
	   " Ʀϧ 'Ԧ",			/* 55 */
	   " :   Z-צ",	/* 56 */
	   "  ",			/* 57 */
	   "Ȧ Ǧæ ",			/* 58 */
	   "צΦ  Ҧ",			/* 59 */
	   "  Ťæ ",			/* 60 */
	   "Ȧ     \"\"",	/* 61 */
	   "Ȧ     \"\"",/* 62 */
	   "Ȧ     \"X-\"",	/* 63 */
	   "Ȧ     \"Z-\"",	/* 64 */
	   "  ",			/* 65 */
	   " Ԧ"			/* 66 */
};

#if 0
 		/* 100 */
       /* 101 */
...                       /*  21 */
...                    	/*  22 */
...			/*  23 */
  Ǧ            /*  24 */
 æ  	/*  25 */
#endif

if ((errcod > 40) && (errcod <= 66)) p = errmsg[errcod-41];
else if (errcod < 0) p = " Φ";
     else switch (errcod) {
          case 0:	p = "  צצ";
  	  		break;
  	  case 1:	p = "Ц .";
  	                break;
  	  case 100:	p = " ";
  	  		break;
  	  case 101:	p = "   ";
  	  		break;
  	  default:	p = "צ ";
  	                break;
  	  }
return(p);
}


maria_put(fd, cmd)
int fd;
uchar *cmd;
{
  int i, j, n;
  uchar buf[BUFSIZE];

  if ((n = strlen(cmd)) > 253)
     return(-1);     /*    */

  i = 0;
  buf[i++] = 253;
  for (j=0; j<n; j++) buf[i++] = cod_table[cmd[j]];
//  for (j=0; j<n; j++) buf[i++] = cmd[j];
  buf[i++] = n+1;
  buf[i++] = 254;
  if (write(fd, buf, i) != i)
     return(-2);     /*  /    */
  return(0);
}

maria_get(fd, cmd, clear_iobuf)
int fd;
uchar *cmd;
int clear_iobuf;
{
  int i, j;
  static uchar buf[BUFSIZE];
  static int l = 0;
  static int m = 0;
  uchar *p;

  if (clear_iobuf) l = m = 0;

  if (m==l) { 
      m = 0; 
      j=l=read_box(fd, buf, printer_delay, NULL);  /*   */
  }

  if (l>0) {
     while (buf[m++] != maria_BEG) if (m>l) {
                               m = l = 0;
                               return(-1);
                             }
     p = &buf[m];

     while (buf[m++] != maria_END) if (m>l) {
                               m = l = 0;
                               return(-1);
                             }

     j = ( buf[m-2] & 0377 ) - 1;

     for (i=0; i < j; i++) cmd[i] = p[i];
     cmd[i] = '\0';
    }
  return(j);
}

maria_info(fd, clear_iobuf)
int fd;
int clear_iobuf;
{
  int l;
  uchar buf[BUFSIZE];
  /* 0 - timeout
     <0 - hardware
      10-20 - info
      20-40 - warnings
      40-70 - errors
   */

  l=maria_get(fd, buf, clear_iobuf);
  if (l>0) {
     if (!strcmp("DONE", buf)) {
        return(COD_DONE);
     }
     if (!strcmp("READY", buf)) {
        printer_delay = 0.5;
        return(COD_READY);
     }

/* warnings */
     if (!strcmp("WRK", buf)) {
//        printer_delay += 2.0;
        return(COD_WARN+1);
     }
     if (!strcmp("PRN", buf)) {
        printer_delay += 0.5;
        return(COD_WARN+2);
     }
     if (!strcmp("WAIT", buf)) {
        printer_delay += 0.5;
        return(COD_WARN+3);
     }
     if (!strcmp("SOFTREGIST", buf)) {
        return(COD_WARN+4);
     }
     if (!strcmp("SOFTMONEY", buf)) {
        return(COD_WARN+5);
     }

/* information */
     if (!strncmp("COMP", buf, 4)) {
        return(COD_INFO);
     }
     if (!strncmp("FISC", buf, 4)) {
        return(COD_INFO+1);
     }

/* errors */
     if (!strcmp("HARDPAPER", buf)) {
        return(COD_ERROR+1);
     }
     if (!strcmp("HARDSENSOR", buf)) {
        return(COD_ERROR+2);
     }
     if (!strcmp("HARDPOINT", buf)) {
        return(COD_ERROR+3);
     }
     if (!strcmp("HARDTXD", buf)) {
        return(COD_ERROR+4);
     }
     if (!strcmp("HARDTIMER", buf)) {
        return(COD_ERROR+5);
     }
     if (!strcmp("HARDMEMORY", buf)) {
        return(COD_ERROR+6);
     }
     if (!strcmp("HARDLCD", buf)) {
        return(COD_ERROR+7);
     }
     if (!strcmp("SHUTDOWN", buf)) {
        return(COD_ERROR+8);
     }
     if (!strcmp("SOFTBLOCK", buf)) {
        return(COD_ERROR+9);
     }
     if (!strcmp("SOFTNREP", buf)) {
        return(COD_ERROR+10);
     }
     if (!strcmp("SOFTSYSLOCK", buf)) {
        return(COD_ERROR+11);
     }
     if (!strcmp("SOFTCOMMAN", buf)) {
        return(COD_ERROR+12);
     }
     if (!strcmp("SOFTPROTOC", buf)) {
        return(COD_ERROR+13);
     }
     if (!strcmp("SOFTZREPOR", buf)) {
        return(COD_ERROR+14);
     }
     if (!strcmp("SOFTMFULL", buf)) {
        return(COD_ERROR+15);
     }
     if (!strcmp("SOFTTIMER", buf)) {
        return(COD_ERROR+16);
     }
     if (!strcmp("SOFTPARAM", buf)) {
        return(COD_ERROR+17);
     }
     if (!strcmp("SOFTUPAS", buf)) {
        return(COD_ERROR+18);
     }
     if (!strcmp("SOFTCHECK", buf)) {
        return(COD_ERROR+19);
     }
     if (!strcmp("SOFTFACT", buf)) {
        return(COD_ERROR+20);
     }
     if (!strcmp("SOFTSLWORK", buf)) {
        return(COD_ERROR+21);
     }
     if (!strcmp("SOFTSLPROG", buf)) {
        return(COD_ERROR+22);
     }
     if (!strcmp("SOFTSLZREP", buf)) {
        return(COD_ERROR+23);
     }
     if (!strcmp("SOFTSLNREP", buf)) {
        return(COD_ERROR+24);
     }
     if (!strcmp("SOFTREPL", buf)) {
        return(COD_ERROR+25);
     }
     if (!strcmp("SOFTOVER", buf)) {
        return(COD_ERROR+26);
     }



     return(-1);
  }
  return(l);
}

/* maria_cmd -       
 * Return:
 *  <0 -  
 *   0 - 
 *   1 - OK
 *   2 - OK,      
 *   >2 -  c  
 *
 */
maria_cmd(fd, cmd)
int fd;
uchar *cmd;
{
  int cmd_error;

  cmd_error = -2;
#ifdef DEBUG
  fprintf(stderr, "maria_cmd: %s\n", cmd);
#endif
  if (maria_put(fd, cmd) == 0) {
     while ((cmd_error=maria_info(fd, 0)) < COD_ERROR) {
        if (cmd_error<=0) break; /*     */
      }
      /* C     !!! */
      if (cmd_error == COD_READY) cmd_error = 1;
      else if (cmd_error==COD_DONE) {/*   DONE  */
                                /* -      READY */
        while ((cmd_error=maria_info(fd, 0)) < COD_ERROR ) {
          if (cmd_error<=0) break;
        }
        if (cmd_error == COD_READY)
           cmd_error = 1;       /*      */
        else
           cmd_error = 2;       /*  ,    */
      }
  }
#ifdef DEBUG
  fprintf(stderr, "maria_cmd return: %d\n", cmd_error);
#endif
  return(cmd_error);
}

/* add_check -        
 *                .
 * Return:
 *   NULL -  (   ), 
 *     struct check_record
 *
 */

check_record *add_check(check, name, sum, sed, num, nalog)
check_record *check; /*    , NULL   */
uchar *name;                /* 30 .       */
double sum;                 /*       */
double sed;                 /*  .        */
double num;                 /* -               */
int    nalog;        /*   1-8, 0 -   */
{
  int i;

  if (check == NULL) {
     if ((check = malloc((size_t) sizeof(check_record))) == NULL)
        return(NULL);
     check->pred = NULL; /*   -   pred=NULL       */
  }
  else {
     while (check->next != NULL) check = check->next;
     if ((check->next = malloc((size_t) sizeof(check_record))) == NULL) 
        return(NULL);
     else {
        check->next->pred = check;
        check = check->next;
     }
  }
  check->next = NULL;
  strncpy(check->name, name, TOVAR_NAMLEN);
  check->sum = sum;
  check->sed = sed;
  check->num = num;
  check->nalog = nalog;
  return(check);
}

void maria_wait_child(int sig) {
  int status;
  
  if (maria_SON) {
     waitpid(maria_SON, &status, 0);
     maria_SON = 0;
  }
}

/*
 * maria_connect -      
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 */
maria_connect(port_name, fd, cassir, password, stty)
uchar * port_name;
int* fd;
uchar *cassir;
uchar *password;
struct termios *stty;
{
  int i, l;
  uchar buf[BUFSIZE];
  
  maria_wait_child(0);
  i = 0;
  if (strncmp(local_port, port_name, strlen(local_port)) != 0)
   while (mdm_lock(port_name) != 0) {
     sleep(1);
     if (i++ > MARIA_DISCONNECT_TIMEOUT) return(-1);
   }
  
  if ((*fd = open_port(port_name, B57600, 8, 'E', 2, 1, stty)) == -1) {
     return(-1);
  }

  printer_delay = 0.5;

  for (i=0; i<MARIA_MAX_ATTEMPTS; i++) { /*   */
#ifdef DEBUG
    fprintf(stderr, "\nAttempt: %d\n", i);
#endif
    buf[0] = 'U';
    write(*fd, buf, 1);
    if ((l=maria_info(*fd, 1)) == COD_READY) break;  /*   */
#ifdef DEBUG
    else fprintf(stderr, "Read return %d\n", l);
#endif
  }

  if (l == COD_READY) {                     /*   */
    for (i=0; i<MARIA_MAX_ATTEMPTS; i++) {
      sprintf(buf, "UPAS%10s%4s", password, cassir);
      l=maria_cmd(*fd, buf);
      if ((l == 1) || (l == 2)) break;
    }
#ifdef DEBUG
    fprintf(stderr, "Info done (%d): %s\n", l, buf);
#endif
  }

  return(l);
}


/*
 * maria_disconnect -    
 * Return:
 *    1 - OK ( )
 */
maria_disconnect(port_name, fd, stty)
uchar * port_name;
int* fd;
struct termios *stty;
{
  int i, l;
  uchar buf[BUFSIZE];
  int status;
  
  i = 0;
  close_port(*fd, stty);
  if (strncmp(local_port, port_name, strlen(local_port)) != 0) {
   signal(SIGCHLD, maria_wait_child);
   if ((maria_SON = fork()) == 0) {
     if (mdm_relock(port_name)) perror("relock line"); 
     sleep(MARIA_DISCONNECT_TIMEOUT);
     if (mdm_unlock(port_name)) perror("removing lock file");
     exit(0);
   }
   waitpid(maria_SON, &status, WNOHANG);
  }
  return(1);
}

free_check(check)
check_record *check;
{
  while (check->next != NULL) check = check->next;
  while (check->pred != NULL) {
     check = check->pred;
     free(check->next);
  }
  free(check);
}

/*
 * maria_day_report -      
 *    -301
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */

maria_day_report(port_name, saler, password, clr_reg)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
int clr_reg;    /*    ? 0 - , 1 -  */
{
  uchar  buf[20];
  int fd;
  struct termios stty;
  int l;

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
//  press_any_key("   צ Ħ    `X'");
    if (clr_reg) strcpy(buf, "NREP");
    else strcpy(buf, "ZREP0");
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_date_report -     
 *   
 *    -301
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */

maria_date_report(port_name, saler, password, day_from, month_from, year_from,
                  day_to,month_to,year_to)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
/*    */
int  day_from;          /*   */
int  month_from;        /*  */
int  year_from;         /*    */
/*    */
int  day_to;            /*   */
int  month_to;          /*  */
int  year_to;           /*    */
{
  uchar  buf[20];
  int fd;
  struct termios stty;
  int l;

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    sprintf(buf, "IREP%4d%02d%02d%4d%02d%02d", year_from, month_from, day_from,
            year_to, month_to, day_to);
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_nalog -  ,   1-8
 * Return:
 *   <0 -    -1 -    
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
maria_nalog(port_name, saler, password, name, number, included, percent)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
uchar *name;     /*   5 */
int number;     /*   1-8 */
int included;   /*  : 0 - ,  - ) */
double percent; /*   */
{
  uchar buf[BUFSIZE];
  int fd;
  struct termios stty;
  int i, l;

  if ((number < 1) || (number > 8) || (percent >= 100.00) || (percent <= 0.0))
     return(9);

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    bzero(buf, 20);
    switch (number) {
     case 1:    i = '';
                break;
     case 2:    i = '';
                break;
     case 3:    i = '';
                break;
     case 4:    i = '';
                break;
     case 5:    i = '';
                break;
     case 6:    i = '';
                break;
     case 7:    i = '';
                break;
     case 8:    i = '';
                break;
    }
    i &= 0377;
    sprintf(buf, "NNAM%c", i);
    strncat(buf, name, 5);
    l=maria_cmd(fd, buf);
  }
  if (l == 1) {
    bzero(buf, 20);
    sprintf(buf, "NALG%c%1d%04d", i, included ? 0 : 1,
            (int) (floor(percent * 100)) );
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_time -     (  +- 1  !!!)
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
maria_time(port_name, saler, password, hour, min, sec)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
int hour;       /*  */
int min;        /*  */
int sec;        /*  */
{
  uchar buf[BUFSIZE];
  int fd;
  struct termios stty;
  int l;

  if ((hour < 0) || (hour > 23) || (min < 0 ) || (min > 60) 
     || (sec < 0 ) || (sec > 60)) return(9);

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    bzero(buf, 20);
    sprintf(buf, "CTIM%02d%02d%02d", hour, min, sec);
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_indicator -     ( 16 )
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
maria_indicator(port_name, saler, password, nstr, message)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
int nstr;       /*   - 1  2 */
uchar *message;   /*  16 ;  NULL    -  */
{
  uchar buf[BUFSIZE];
  int fd;
  struct termios stty;
  int l;

  if ((nstr < 1) || (nstr > 2)) return(9);

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    bzero(buf, 25);
    if ((message == NULL) || (strlen(message) == 0)) strcpy(buf, "DISP");
    else {
      sprintf(buf, "DISP%1d", nstr);
      strncat(buf, message, 16);
    }
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_linefeed -   
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
maria_linefeed(port_name, saler, password, nstr)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
int nstr;       /*   - 1  2 */
{
  uchar buf[BUFSIZE];
  int fd;
  struct termios stty;
  int l;

  if ((nstr < 0) || (nstr > 255)) return(9);

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    bzero(buf, 25);
    sprintf(buf, "FEED%03d", nstr);
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}

/*
 * maria_linefeed -   
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
maria_stamp(port_name, saler, password, nstr)
uchar *port_name;
uchar *saler;    /*   4 */
uchar *password;
int nstr;       /*      1-255 */
{
  uchar buf[BUFSIZE];
  int fd;
  struct termios stty;
  int l;

  if ((nstr < 0) || (nstr>255)) return(9);
  if (nstr == 0) return(1);

  bzero(buf, 5);
  strncpy(buf, saler, 4);
  l = maria_connect(port_name, &fd, buf, password, &stty);
  if (l == 1) {
    bzero(buf, 25);
    sprintf(buf, "STAM%03d", nstr);
    l=maria_cmd(fd, buf);
  }
  maria_disconnect(port_name, &fd, &stty);
  return(l);
}


/*
 * maria_prcheck -      -301
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */
maria_prcheck(check, returned,
sum, sum_tara, sum_pcheck, sum_cred, sum_nal,
port_name, otd, saler, password, head, botm, text_A, bold_A, text_Z, bold_Z)

check_record *check;
int returned;            /*    ? 0 - ,  -  */
double sum;
double sum_tara;
double sum_pcheck;
double sum_cred;
double sum_nal;
uchar *port_name;
uchar *otd;              /*   .,  2  */
uchar *saler;            /* ,  4- .  */
uchar *password;         /*  10 */
uchar *head;             /*   18  */
uchar *botm;             /*   18 */
uchar *text_A;           /* ,    , 50*18 */
int   bold_A;           /*   - 0,  - 1 */
uchar *text_Z;           /* ,    , 50*18 */
int   bold_Z;           /*   - 0,  - 1 */

{
  struct termios stty;
  int fd, i, j, k, l;
  int sr, se, ni, delim, how_round;
  double nint, nmant;
  uchar buf[BUFSIZE];
  uchar* nal[8];
  uchar  short_name[13];
  uchar  *p;

  l = 1;
  if (check != NULL) {
       how_round = 0;  /* c,   -    */

       /*   */
       bzero(short_name, 5);
       strncpy(short_name, saler, 4);
       l = maria_connect(port_name, &fd, short_name, password, &stty);

       /*    */
       if (l == 1) {
          strcpy(buf, "CTXT");     
          l = maria_cmd(fd, buf);
       }

       /*     */
       if (l == 1) {
          strcpy(buf, "PPOD1");     
          l = maria_cmd(fd, buf);
       }

        /*   */
       if (l == 1) {
        bzero(buf, 10);
        strcpy(buf, "PREP");
        strncat(buf, otd, 2);
        l=maria_cmd(fd, buf);
       }

       /*         -
         */
       if (head && (l == 1)) {
          bzero(buf, 30);
          strcpy(buf, "HEAD");
          strncat(buf, head, 18);
          l=maria_cmd(fd, buf);
       }


       /*         -
         */
       if (botm && (l == 1)) {
          bzero(buf, 30);
          strcpy(buf, "BOTM");
          strncat(buf, botm, 18);
          l=maria_cmd(fd, buf);
       }


       /*        
         -    */
       if (text_A && (l == 1)) {
          sprintf(buf, "TEXT00%1d", bold_A ? 1 : 0);
          for (i=0; i<50*18; i+=18) {
            if ((i>=strlen(text_A)) || (l != 1)) break;
            bzero(&buf[7], 19);
            strncat(&buf[7], &text_A[i], 18);
            l=maria_cmd(fd, buf);
          }
       }


       /*        
         -    */
       if (text_Z && (l == 1)) {
          sprintf(buf, "TEXT10%1d", bold_Z ? 1 : 0);
          for (i=0; i<50*18; i+=18) {
            if ((i>=strlen(text_Z)) || (l != 1)) break;
            bzero(&buf[7], 19);
            strncat(&buf[7], &text_Z[i], 18);
            l=maria_cmd(fd, buf);
          }
       }


       /*      - 
           */
       if (l == 1) {
          /*      */
          while (check->pred != NULL) check=check->pred;

          while (1) {
             sr = kop(check->sum);
             se = kop(check->sed);
             nint = floor(check->num);
             if (nint == 0.0) nmant = check->num;
             else nmant = fmod(check->num, nint);
             if (nmant >= 0.001) {
                delim = 0;
                ni = floor(check->num*1000);
             }
             else {
                delim = 1;
                ni = floor(check->num);
             }
             for (i=0; i<8; i++) nal[i] = "000000";
             j = 0;
             if ((i=strlen(check->name)) > 12) {
                bzero(buf, TOVAR_NAMLEN);
                strcpy(buf, "FINF");
                strncat(buf, check->name, 18);
                if ((l=maria_cmd(fd, buf)) != 1) break;
                j = 18;
             }
             bzero(short_name, 13);
             strncpy(short_name, &check->name[j], 12);
             sprintf(buf, "%s%-12s%09d%09d%05d%1d%1d%6s%6s%6s%6s%6s%6s%6s%6s",
                     returned ? "BFIS" : "FISC",
                     short_name, sr, se, ni, delim, how_round,
                     nal[0], nal[1], nal[2], nal[3], nal[4],
                     nal[5], nal[6], nal[7]);
/*
printf("sr=%d (from %f)\n", sr, check->sum);
printf("%s\n", buf);                     
*/
             if ((l=maria_cmd(fd, buf)) != 1) break;
             else if (check->next != NULL) check = check->next;
                  else break;
          }
/*
printf("\n\rBFIS/FISC result=%d\n", l);
sleep(1);
*/
          if (l == 1) {
            sprintf(buf, "DISP1%s", "  :");
            l=maria_cmd(fd, buf);
            sprintf(buf, "DISP2%.2f", sum);
            l=maria_cmd(fd, buf);
            sprintf(buf, "COMP%010d%010d%010d%010d%010d%010d",
                        kop(sum), 0, kop(sum_tara), kop(sum_pcheck),
                        kop(sum_cred), kop(sum_nal));
            l=maria_cmd(fd, buf);
           }
           if (l == 1) free_check(check);
       }
       maria_disconnect(port_name, &fd, &stty);
  }
  return(l);
}

