/* $Id */
#ifndef _LIBDEV_H
#define _LIBDEV_H
typedef unsigned char uchar;
/*typedef unsigned int uint;*/

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

/*========================= -802===================================*/
/* era_open() -    
 *
 * Return:
 *  -1 -   
 *    file descriptor
 * 
 */
extern int era_open(char *port_name);

/* era_close() -     */
#define era_close() era_open(NULL);

/* era_prog_tovar() -       .
 *
 * :         ,
 *                 
 *             (     Z)
 *
 * Return:
 *   -4 -   
 *   -3 -    . ,   .
 *   -2 -  /
 *   -1 -   
 *    0 -   
 *   >0 - OK
 */
extern int era_prog_tovar(
     int	fp,		/* file descriptor		*/	       
     char	*password,	/* 			*/
     uint 	cod,		/*   1-2500 		*/
     uchar 	*name,		/*  12  	*/
     uint 	gr_NDS,		/*   0-4 		*/
     uint 	gr_TOV, 	/*   1-32 	*/
     char 	*barcode,	/* -, 13  	*/
     uint 	depart,		/*  0-31 			*/
     uint 	drob,	 	/* 0 -  -  , 
     				 ..  	*/
     uint 	test_ost,/* 0 -     , 
     				 -  	*/
     double 	cena,		/*   		*/
     double 	ost		/*   () 	*/
);

/*     . 
      '?'     */
struct tovar_info_struct {
   struct tovar_info_struct *next;	/*   . -  */
   struct tovar_info_struct *pred;	/*   . -  */
   uint cod;		/*   */
   int  num;		/* -   */
   double sum;		/* c  */
   double cena;		/* ? .	*/
   uint depart;		/* ?	*/
   char name[13];       /*  */
   char barcode[14];	/* ?-	*/
};

typedef struct tovar_info_struct tovar_info;

/* era_otch_tovar() -     
 *
 * Return:
 * >= 0 - -  ;
 * <0   -   
 */
extern int era_otch_tovar (
  int fp,		/* file descriptor	*/
  char *password,	/*  		*/
  uint first,           /*  ,  .   1-2500 */
  uint last,		/*  , .   1-2500 */
  tovar_info **chain	/*      -  */
);

/* free_tovar_list() -  ,  
 *                     
 */
extern int free_tovar_list (
   tovar_info **pt	/*       */
   );

/*===========================  -301=================*/

#define TOVAR_NAMLEN 30

/* C     */
struct check_rec_struct {
       struct check_rec_struct *next; /*   .    */
       struct check_rec_struct *pred; /*   .    */
       uchar name[TOVAR_NAMLEN+1];  /* .                         */
       double sum;                /*                      */
       double sed;                /*  .        */
       double num;                /* -                              */
       int    nalog;              /*  , 1-8; 0 -     */
       };

typedef struct check_rec_struct check_record;

/* add_check -        
 *                .
 *  :
 *   check -    , NULL  
 *   name  - 30 . 
 *   sum   -  
 *   sed   -  .
 *   num   - -
 *   nalog -   1-8, 0 -  
 *
 * Return:
 *   NULL -  (   ), 
 *     struct check_record
 *
 */

extern check_record *
add_check(check_record *check, uchar *name,
          double sum, double sed, double num, int nalog);

/*
 * maria_prcheck -      -301
 *
 *  :
 *   check    -    ,
 *   returned -    ? 0 - ,  - 
 *   sum      -    
 *      :
 *     sum_tara - 
 *     sum_pcheck -  
 *     sum_cred - 
 *     sum_nal  - 
 *   port_name -    ,  .  
 *   otd      -   .,  2 
 *   saler    - ,  4- .
 *   password -  10
 *   head     -   18
 *   botm     -   18
 *   text_A   - ,    , 50*18
 *   bold_A   -   - 0,  - 1
 *   text_Z   - ,    , 50*18
 *   bold_Z   -   - 0,  - 1
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */
extern int 
maria_prcheck(check_record* check, int returned,
double sum, double sum_tara, double sum_pcheck, double sum_cred, double sum_nal,
uchar* port_name, uchar* otd, uchar* saler, uchar* password,
uchar* head, uchar* botm,
uchar* text_A,
int bold_A,
uchar* text_Z,
int bold_Z);

/*
 * maria_day_report -      
 *    -301
 *
 *  :
 *   port_name -    ,  .  
 *   saler    -   4
 *   password - 
 *   clr_reg  -    ? 0 - , 1 - 
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */
extern int 
maria_day_report(uchar * port_name, uchar * saler, uchar * password,
                int clr_reg);

/*
 * maria_date_report -     
 *   
 *    -301
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *      :
 *     day_from   - 
 *     month_from - 
 *     year_from  - 
 *     :
 *     day_to   - 
 *     month_to - 
 *     year_to  - 
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *   >2 -  coo  
 *
 */

extern int 
maria_date_report(uchar * port_name, uchar * saler, uchar * password,
                  int day_from, int month_from, int year_from,
                  int day_to, int month_to, int year_to);

/*
 * maria_nalog -  ,   1-8
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   name     -   5
 *   number;  -   1-8
 *   included -  : 0 - ,  - 
 *   percent  -  
 *
 * Return:
 *   <0 -    -1 -    
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
extern int 
maria_nalog(uchar * port_name, uchar * saler, uchar * password,
            uchar * name, int number, int included, double percent);


/*
 * maria_time -     (  +- 1  !!!)
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   hour - 
 *   min  - 
 *   sec  - 
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
extern int 
maria_time(uchar * port_name, uchar * saler, uchar * password, 
           int hour, int min, int sec);

/*
 * maria_indicator -     ( 16 )
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   nstr  -   - 1  2
 *   message -  16 ;  NULL    -  
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
extern int 
maria_indicator(uchar * port_name, uchar * saler, uchar * password, 
                int nstr, uchar * message);

/*
 * maria_linefeed -   
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   nstr  - -  , 1-255
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
extern int 
maria_linefeed(uchar * port_name, uchar * saler, uchar * password, 
               int nstr);

/*
 * maria_stamp -  
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   nstr  -      1-255
 *
 * Return:
 *   <0 -  
 *    0 - 
 *    1 - OK
 *    2 -  ,  -  
 *    9 -   
 *   >2 -  coo  
 *
 */
extern int 
maria_stamp(uchar * port_name, uchar * saler, uchar * password, 
           int nstr);

/*        */
extern uchar * maria_error(int errcod);

/*======================= -===============================*/

/*
 * scan -    -
 *  :
 *   tty_name -    ,    
 *   timeout  -  .    (NULL,  )
 *   kbhit   -    ,                
 *                .    
 *               ; ,    
 *                            
 *               : 
 *
 *             0 -   ;
 *             1 -  
 *
 *              NULL,      
 *              
 *
 *
 *  :
 *   ret_cod  -  c   -
 *
 * Return:
 *     >0 -  ,  
 *     0  -      
 *    -1  -    
 *    -2  -  /
 *    -3  -   
 */

extern int scan (uchar *tty_name, double timeout, uchar *ret_cod, 
                int (*kbhit)());

/*===================== AP-1=========================================*/

/*
 * ves -     
 *
 *  :
 *   tty_name -   ,    
 *               "local" - ,   
 *   attempts - .     
 *   timeout  - .   
 *   kbhit   -    ,                
 *                .    
 *               ; ,    
 *                            
 *               : 
 *
 *             0 -   ;
 *             1 -  
 *
 *              NULL,      
 *              
 *
 * :
 *   ret_ves  - c   
 *
 * Return:
 *     1  -  
 *     0  -      
 *    -1  -    
 *    -2  -  /
 *    -3  -   
 *
 */
extern int ves  (uchar *tty_name, int attempts, double timeout, 
                double *ret_ves, int (*kbhit)());

#endif
