/* $Id: local.h,v 1.1 1999/10/04 18:48:13 maxime Exp $ */
#include <fcntl.h>
#include <termios.h>
#ifdef SELECT
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#endif

#ifndef CONFIG_INI      
#       define CONFIG_INI "iceb.ini"
#endif

#define BUFSIZE 512

#define MARIA_MAX_ATTEMPTS 10
#define default_port_name "local" 
#define local_port "local"

/*   (double) ->  (int) */
#define kop(grn) ((int) rint(grn * 100))

/* . 	*/
#define SOH     '\1'
#define STX     '\2'
#define ETX     '\3'
#define EOT     '\4'
#define ENQ     '\5'
#define ACK     '\6'
#define DC1     '\x11'
#define DC2     '\x12'
#define NAK1    '\x14'
#define NAK     '\x15'
#define NAK2    '\x16'

/*-----------------------I/O functions-----------------------------*/
/*
 * open_port -      
 *  :
 *   pn -    
 *   baud - c   B_XXXX
 *   bit -   : 8, 7  0 -  
 *   parity - : 'E' , 'N'   , 'O' , 0 -  
 *   stop_bit - 1, 2  0 - 
 *   full_modem = 0 - - ;
 *              = 1 - 
 *                    
 *
 *  :
 *   old_stty -    
 *
 * Return:  file descriptor - OK
 *          -1 - 
 */
extern int open_port (uchar * port_name, speed_t baud,
                      int bit,
                      int parity,
                      int stop_bit,
                      int full_modem,
                      struct termios *old_stty);

/* close_port -      
 *              stty-
 *
 *  :
 *   port - file descriptor  
 *   old_stty -     stty-
 *
 * Return: -
 *
 */
extern int close_port(int port, struct termios *old_stty);

/* read_box() -    ,  
 *               ,  .
 *
 *  :
 *   fp - file descriptor  
 *   timeout -  ,  
 *   kbhit   -    ,                
 *                .    
 *               ; ,    
 *                            
 *               : 
 *
 *             0 -   ;
 *             1 -  
 *
 *              NULL,      
 *              
 *
 *  :
 *   buffer -   ,   
 *            
 *
 * Return: 0  - 
 *         -1 -   
 *         -2 -  /
 *         >0 -   
 */

extern int read_box(int fp, uchar *buffer, float timeout, int (*kbhit)());

/* mdm_lock() -   
 * Return: 0 - OK
 *         1 -   
 */
extern int mdm_lock(char *line);

/* mdm_unlock() -   
 * Return: 0 - OK
 *         1 -   
 */
extern int mdm_unlock(char *line);

/* mdm_relock() -     
 * Return: 0 - OK
 *         1 -   
 */
extern int mdm_relock(char *line);

