/* $Id: maria.c,v 1.1 1999/10/04 18:48:13 maxime Exp $ */
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/types.h>
#include <libconfig.h>
#include "libdev.h"
#include "local.h"

#define default_password "1111111111"

press_any_key(prompt)
{
    char buf[2];

    if (prompt)
       printf("%s", prompt);
    printf(". Φ צ Enter...");
    fgets(buf, 1, stdin);
}

menu(char *title, ...)
{
  va_list ap;
  char *p;
  int  i;

  printf("\n%s:\n\n", title);
  i = 0;
  va_start(ap, title);
    while ((p = va_arg(ap, char*)) != NULL) printf("\t%2d - %s\n", i++, p);
  va_end(ap);
  printf("\n ¦: ");
  scanf("%d", &i);
  return(i);
}

main() {
  config_t foo;
  uchar buf[BUFSIZE];
  int fd, i, l;
  check_record *mycheck;
  char *port_name;
  char *ps;
  char *p;
  
  port_name = default_port_name;
  ps = default_password;


  if (p=getenv("HOME")) strncpy(buf, p, BUFSIZE-30);
  else strcpy(buf, ".");
  strcat(buf, "/");
  strncat(buf, CONFIG_INI, 29);
  config_new(&foo);
  if(config_read(&foo, buf, CS_INI, NULL)) {
	perror(buf);
  } else {
    fprintf(stderr, "Reading config file ...\n");
    read_vars(&foo, "CASSA", 
  	     "device", CHARPTR_T, &port_name,
  	     "password", CHARPTR_T, &ps,
             NULL);

    config_destroy(&foo);
  }

#ifdef DEBUG
  printf("Port: %s\n", port_name);
  printf("Password=%s\n", ps);
#endif    

  while (i = menu("  ", " ", " ̦æ",
      " ", " צ  ",
      " צ  ", "צ   Ҧ",
      " ", " ",
      "   Ҧ", "  Ҧ",
      "", NULL )) {

       switch (i) {
       case 1:
            if (!(mycheck = add_check(NULL, 
               "  ()", 10.00, 10.00, 1.00, 0))) {
               show_error("   ");
               break;
            }
            if (!(mycheck = add_check(mycheck, "", 2.50, 5.00, 0.5, 0))) {
               show_error("   ");
               break;
             }
            if (!(mycheck = add_check(mycheck, "Ҧ", 6.00, 3.00, 2.00, 0))) {
               show_error("   ");
               break;
             }

             i=maria_prcheck(mycheck, 0, 18.5, 2.0, 5.0, 3.0, 8.5,
             port_name, "11", "", ps, "", "",
             NULL, 0, NULL, 0);
/*             "  ,     Ʀϧ æ", 0,
             "  ,    ˦æ Ʀϧ æ,   Ħ", 1);
*/             
             break;

       case 2:
             if (!(mycheck = add_check(NULL, " ", 
                   3.00, 3.00, 1.00, 0))) {
               show_error("   ");
               break;
             }
             i=maria_prcheck(mycheck, 1, 3.0, 0.0, 0.0, 0.0, 3.0,
                  port_name, "12", "", ps, NULL, NULL, NULL, 0, NULL, 0);

             break;

       case 3:
             i = maria_day_report(port_name, "", ps, 0);
             break;

       case 4: /* " צ  " */
             i = maria_day_report(port_name, "", ps, 1);
             break;

       case 5: /* צ   Ҧ */
             i = maria_date_report(port_name, "",ps, 1,1,1998, 31,12,1998);
             break;
       case 6: /*   */
              i = maria_nalog(port_name, "",ps, "", 1, 1, 20.00);
              break;
       case 7: /*   */
              i = maria_time(port_name, "",ps, 15, 10, 00);
              break;
       case 8: /*    Ҧ */
              i = maria_indicator(port_name, "",ps, 1, "դ!");
              break;
       case 9: /*   Ҧ */
              i = maria_linefeed(port_name, "",ps, 5);
              break;
       case 10: /*  */
              i = maria_stamp(port_name, "",ps, 1);
              break;
       default:
              show_error(" æ");
              break;
       }
       printf("%s (code=%d)\n", maria_error(i), i);
  }

  return(0);
}

read_int() {
  uchar buf[BUFSIZE];
  int i, l;

 l = read(fileno(stdin), buf, BUFSIZE-1);
/* l = 1;
 buf[0] = getch();
*/

#ifdef DEBUG
  fprintf(stderr, "KEYBOARD INTERRUPT:(%d)\n", l);
  for (i=0; i<l; i++) if (buf[i] > '\040') fputc(buf[i], stderr);
                      else fprintf(stderr, " ^%c ", buf[i]+64);
  fputc('\n', stderr);
#endif
/*
  if ((buf[0] == 'q') || (buf[0] == 'Q')) return(1);
  else 
*/
return(1);
}

show_cod(uchar *cod) {
  int i;
  printf("CODE: ");
  for (i=0; i<strlen(cod); i++) if ((cod[i] & 0377) > '\040') putchar(cod[i]);
                      else printf(" ^%c ", cod[i]+64);
  putchar('\n');
}

show_error(uchar *msg) {
  fprintf(stderr, "%s\n", msg);
  sleep(1);
}
