/* $Id: scan.c,v 1.1 1999/10/04 18:48:13 maxime Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <sys/types.h>
#include <libconfig.h>
#include "libdev.h"
#include "local.h"

//#define CLEAR_PRED_INPUT
#define COD_PREFIX ENQ

/*
 * scan -    -
 * Return:
 *     >0 -  ,  
 *     0  -      
 *    -1  -    
 *    -2  -  /
 *    -3  -   
 */
int scan (tty_name, timeout, ret_cod, kbhit)
uchar *tty_name; /*   ,    */
double timeout;  /* .    (<0,  )                 */
uchar *ret_cod;  /* c   -                     */
int (*kbhit)();
{
  int l;
  int fp;
  uchar buf[BUFSIZE];
  struct termios stty;
  
  ret_cod[0] = '\0';
  if (mdm_lock(tty_name)) return(-3);
  /*  ,     */
  if ((fp=open_port(tty_name, B9600, 8, 'N', 1, 1, &stty)) == -1) {
      /*   -   */
      mdm_unlock(tty_name);
      return(-3);
  }

  l=get_cod(fp, ret_cod, timeout, kbhit);        /*  - */
  close_port(fp, &stty);
  mdm_unlock(tty_name);
  return(l);
}

/*
 * get_cod -  -
 * Return:
 *      0 -     
 *     -1 -   
 *     >0 -   
 */
int get_cod(fd, cod, timeout, kbhit)
int fd;         /* file descriptor   */
uchar *cod;
double timeout;
int (*kbhit)();
{
   int i, j, k;
   uchar buf[BUFSIZE];

#ifdef CLEAR_PRED_INPUT
   i = read_box(fd, buf, 0.1, NULL);
#endif
   i = read_box(fd, buf, timeout, kbhit);
   if (i > 0) { /*                                         */
      if ((fd == fileno(stdin)) &&  /*    -       */
           (buf[0] != COD_PREFIX))  /*   ,     
                                           ec  -    
                                            
                                     */
         for (--i; i >= 0; i--)     /*                   */
               ungetc(buf[i], stdin);
                                    /*  i = -1 */
      else { /*               */
             /*                    */
         for (j=0; j<i; j++)
             if (buf[j] > ' ') break;
         k = 0;
         while (j < i) if (buf[j] < ' ') break;
                       else cod[k++] = buf[j++];
         cod[k] = '\0';
         i = k;
      }
   }
   return(i);
}

